#define I_SYS
#define I_ERRNO
#include "includes.h"

#include "client.h"

void do_select_loop(int sock, int in_f, int out_f) {
  struct Buffer in = {0, }, out = {0, };
  int i;
  while (1) {
    fd_set rd, wr;
    
    FD_ZERO(&rd);
    FD_ZERO(&wr);
    
    if (in.size)
      FD_SET(sock, &wr);
    else
      FD_SET(in_f, &rd);
    
    if (out.size)
      FD_SET(out_f, &wr);
    else
      FD_SET(sock, &rd);
    
    select(64, &rd, &wr, 0, 0);
    
    if (FD_ISSET(out_f, &wr)) {
      i = write_from_buff(out_f, &out, 0);
      if (term_errno)
	break;
    }
    if (FD_ISSET(sock, &wr)) {
      i = write_from_buff(sock, &in, 0);
      if (term_errno)
	break;
    }
    
    if (FD_ISSET(in_f, &rd)) {
      i = read_into_buff(in_f, &in);
      if (term_errno)
	break;
    }
    
    if (FD_ISSET(sock, &rd)) {
      i = read_into_buff(sock, &out);
      if (term_errno)
	break;
    }
  }
}



