
/*
 * A client for term.
 */
#define I_IOCTL
#include "includes.h"

#include "client.h"

int debug = 0;
/*---------------------------------------------------------------------------*/
void main(int argc, char *argv[]) {
  int s, i, j, first, size;
  char *file, *remote;
  struct Buffer inb = {0, };
				/* Downgrade priority for file transfers. */
  priority = -2;
  first = client_options(argc,argv);
  if ((argc-first) != 2 && (argc-first) != 1) {
    printf(
     "Usage: upload [-r] [-c] [-p <num>] <local file> [<remote file>]\n");
    exit(1);
  }
  
  file = argv[first];
  if (first == argc-1)
    remote = file;
  else remote = argv[first+1];

  s = connect_server(term_server);
  
  if (strcmp(file, "-")) 
    i = open(file, O_RDONLY);
  else i = 0 ; /* stdin */

  if ( i < 0) {
    fprintf(stderr, "Can't open local file %s\n", file);
    close(s);
    exit(1);
  }
  size = -1;
  if ((send_command(s, C_STAT, 0, "%s", remote)) >= 0)
    size = atoi(command_result);

  if (send_command(s, size>0?C_OPEN:C_UPLOAD, 0, "%s", remote) < 0) {
    fprintf(stderr,"FATAL:Couldn't open remote file\n");
    fprintf(stderr,"Reason given: %s\n", command_result);
    exit(1);
  }

  if (size > 0) {
    fprintf(stderr, "Restarting upload from %d.\n", size);
    if (send_command(s, C_SEEK, 0, "%d", size) < 0) {
      fprintf(stderr, "FATAL:Couldn't resume upload. Remote seek failed\n");
      fprintf(stderr, "Reason given: %s\n", command_result);
      exit(1);
    }
    if (lseek(i, size, 0)<0) {
      fprintf(stderr, "FATAL:Couldn't resume upload. Local seek failed\n");
      perror("Reason given");
      exit(1);
    }
  }

  if (send_command(s, C_DUMB, 1, 0) < 0) {
    fprintf(stderr, "FATAL:Couldn't turn off command processing.\n");
    fprintf(stderr, "Reason given: %s\n", command_result);
    exit(1);
  }

  while (1) {
    if (!inb.size) {
      j = read_into_buff(i, &inb);
      if (j < 1) {
	close(s);
	close(i);
	exit(0);
      }
    }
    else {
      j = write_from_buff(s, &inb, 0);
      if (j < 1) {
	fprintf(stderr, "Damned errors. Sorry. file transfer failed\n");
	perror("write");
	exit(1);
      }
    }
  }
}
